[Libguestfs] [PATCH nbdkit 3/4] tests: Copy test-partitioning4.sh for MBR.

Richard W.M. Jones rjones at redhat.com
Sun Jan 20 20:57:07 UTC 2019


This test is now applicable to MBR too since we started
supporting logical partitions.
---
 tests/Makefile.am           |  4 +-
 tests/test-partitioning4.sh |  2 +-
 tests/test-partitioning6.sh | 92 +++++++++++++++++++++++++++++++++++++
 3 files changed, 96 insertions(+), 2 deletions(-)

diff --git a/tests/Makefile.am b/tests/Makefile.am
index 27abbaf..3afa81a 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -84,6 +84,7 @@ EXTRA_DIST = \
 	test-partitioning3.sh \
 	test-partitioning4.sh \
 	test-partitioning5.sh \
+	test-partitioning6.sh \
 	test-pattern.sh \
 	test-pattern-largest.sh \
 	test-pattern-largest-for-qemu.sh \
@@ -453,7 +454,8 @@ test_memory_LDADD = libtest.la $(LIBGUESTFS_LIBS)
 # partitioning plugin test.
 TESTS += \
 	test-partitioning1.sh \
-	test-partitioning4.sh
+	test-partitioning4.sh \
+	test-partitioning6.sh
 if HAVE_GUESTFISH
 TESTS += \
 	test-partitioning2.sh \
diff --git a/tests/test-partitioning4.sh b/tests/test-partitioning4.sh
index 4177640..f80c7ae 100755
--- a/tests/test-partitioning4.sh
+++ b/tests/test-partitioning4.sh
@@ -33,7 +33,7 @@
 
 # Test the partitioning plugin.
 #
-# Test 4: Test > 128 partitions.
+# Test 4: Test > 128 partitions using GPT.
 #
 # virtio-scsi (used by libguestfs) doesn't support more than 15
 # partitions.  In fact the only client which supports this is our own
diff --git a/tests/test-partitioning6.sh b/tests/test-partitioning6.sh
new file mode 100755
index 0000000..ea84854
--- /dev/null
+++ b/tests/test-partitioning6.sh
@@ -0,0 +1,92 @@
+#!/usr/bin/env bash
+# nbdkit
+# Copyright (C) 2018-2019 Red Hat Inc.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are
+# met:
+#
+# * Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# * Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# * Neither the name of Red Hat nor the names of its contributors may be
+# used to endorse or promote products derived from this software without
+# specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY RED HAT AND CONTRIBUTORS ''AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
+# THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
+# PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL RED HAT OR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+
+# Test the partitioning plugin.
+#
+# Test 4: Test > 128 partitions using MBR.
+#
+# virtio-scsi (used by libguestfs) doesn't support more than 15
+# partitions.  In fact the only client which supports this is our own
+# partition filter so we use that for the test.
+
+source ./functions.sh
+set -e
+set -x
+
+# Check if the printf utility is available.  This is probably using
+# the bash builtin (not the one from coreutils) which does not
+# understand --flags, so we have to test it using a dummy format
+# string.
+if ! printf ""; then
+    echo "$0: missing or broken printf"
+    exit 77
+fi
+
+# Test that qemu-img works
+if ! qemu-img --help >/dev/null; then
+    echo "$0: missing or broken qemu-img"
+    exit 77
+fi
+
+d=partitioning6.d
+rm -rf $d
+mkdir $d
+cleanup_fn rm -rf $d
+
+# Create the partitions.
+for i in {1..768}; do
+    truncate -s 1 $(printf '%s/part.%04d' $d $i)
+done
+
+# Create partition 250 containing data and truncate it to a whole
+# number of sectors.
+rm $d/part.0250
+for i in {0..1000}; do
+    echo -n "hello " >> $d/part.0250
+done
+truncate -s 6144 $d/part.0250
+
+# Run nbdkit.
+#
+# Note we select partition 251 (not 250) because partition 4 is the
+# extended partition and everything partition following moves up by 1.
+nbdkit -f -v -D partitioning.regions=1 -U - \
+             --filter=partition \
+             partitioning \
+             $d/part.* \
+             partition-type=mbr \
+             partition=251 \
+             --run "qemu-img convert \$nbd $d/out"
+
+# The output should be identical to partition 250.
+cmp $d/part.0250 $d/out
-- 
2.20.1




More information about the Libguestfs mailing list